#include "../../pmu-events/pmu-events.h"
struct pmu_event pme_ampere_emag[] = {
{
	.name = "l1d_cache_rd",
	.event = "event=0x40",
	.desc = "L1D cache access, read",
	.topic = "core imp def",
	.long_desc = "Attributable Level 1 data cache access, read",
},
{
	.name = "l1d_cache_wr",
	.event = "event=0x41",
	.desc = "L1D cache access, write",
	.topic = "core imp def",
	.long_desc = "Attributable Level 1 data cache access, write",
},
{
	.name = "l1d_cache_refill_rd",
	.event = "event=0x42",
	.desc = "L1D cache refill, read",
	.topic = "core imp def",
	.long_desc = "Attributable Level 1 data cache refill, read",
},
{
	.name = "l1d_cache_refill_wr",
	.event = "event=0x43",
	.desc = "L1D cache refill, write",
	.topic = "core imp def",
	.long_desc = "Attributable Level 1 data cache refill, write",
},
{
	.name = "l1d_tlb_refill_rd",
	.event = "event=0x4c",
	.desc = "L1D tlb refill, read",
	.topic = "core imp def",
	.long_desc = "Attributable Level 1 data TLB refill, read",
},
{
	.name = "l1d_tlb_refill_wr",
	.event = "event=0x4d",
	.desc = "L1D tlb refill, write",
	.topic = "core imp def",
	.long_desc = "Attributable Level 1 data TLB refill, write",
},
{
	.name = "l1d_tlb_rd",
	.event = "event=0x4e",
	.desc = "L1D tlb access, read",
	.topic = "core imp def",
	.long_desc = "Attributable Level 1 data or unified TLB access, read",
},
{
	.name = "l1d_tlb_wr",
	.event = "event=0x4f",
	.desc = "L1D tlb access, write",
	.topic = "core imp def",
	.long_desc = "Attributable Level 1 data or unified TLB access, write",
},
{
	.name = "bus_access_rd",
	.event = "event=0x60",
	.desc = "Bus access read",
	.topic = "core imp def",
	.long_desc = "Bus access read",
},
{
	.name = "bus_access_wr",
	.event = "event=0x61",
	.desc = "Bus access write",
	.topic = "core imp def",
	.long_desc = "Bus access write",
},
{
	.name = 0,
	.event = 0,
	.desc = 0,
},
};
struct pmu_event pme_cavium_thunderx2[] = {
{
	.name = "l1d_cache_rd",
	.event = "event=0x40",
	.desc = "L1D cache access, read",
	.topic = "core imp def",
	.long_desc = "Attributable Level 1 data cache access, read",
},
{
	.name = "l1d_cache_wr",
	.event = "event=0x41",
	.desc = "L1D cache access, write",
	.topic = "core imp def",
	.long_desc = "Attributable Level 1 data cache access, write",
},
{
	.name = "l1d_cache_refill_rd",
	.event = "event=0x42",
	.desc = "L1D cache refill, read",
	.topic = "core imp def",
	.long_desc = "Attributable Level 1 data cache refill, read",
},
{
	.name = "l1d_cache_refill_wr",
	.event = "event=0x43",
	.desc = "L1D cache refill, write",
	.topic = "core imp def",
	.long_desc = "Attributable Level 1 data cache refill, write",
},
{
	.name = "l1d_cache_refill_inner",
	.event = "event=0x44",
	.desc = "L1D cache refill, inner",
	.topic = "core imp def",
	.long_desc = "Attributable Level 1 data cache refill, inner",
},
{
	.name = "l1d_cache_refill_outer",
	.event = "event=0x45",
	.desc = "L1D cache refill, outer",
	.topic = "core imp def",
	.long_desc = "Attributable Level 1 data cache refill, outer",
},
{
	.name = "l1d_cache_wb_victim",
	.event = "event=0x46",
	.desc = "L1D cache Write-Back, victim",
	.topic = "core imp def",
	.long_desc = "Attributable Level 1 data cache Write-Back, victim",
},
{
	.name = "l1d_cache_wb_clean",
	.event = "event=0x47",
	.desc = "L1D cache Write-Back, cleaning and coherency",
	.topic = "core imp def",
	.long_desc = "Level 1 data cache Write-Back, cleaning and coherency",
},
{
	.name = "l1d_cache_inval",
	.event = "event=0x48",
	.desc = "L1D cache invalidate",
	.topic = "core imp def",
	.long_desc = "Attributable Level 1 data cache invalidate",
},
{
	.name = "l1d_tlb_refill_rd",
	.event = "event=0x4c",
	.desc = "L1D tlb refill, read",
	.topic = "core imp def",
	.long_desc = "Attributable Level 1 data TLB refill, read",
},
{
	.name = "l1d_tlb_refill_wr",
	.event = "event=0x4d",
	.desc = "L1D tlb refill, write",
	.topic = "core imp def",
	.long_desc = "Attributable Level 1 data TLB refill, write",
},
{
	.name = "l1d_tlb_rd",
	.event = "event=0x4e",
	.desc = "L1D tlb access, read",
	.topic = "core imp def",
	.long_desc = "Attributable Level 1 data or unified TLB access, read",
},
{
	.name = "l1d_tlb_wr",
	.event = "event=0x4f",
	.desc = "L1D tlb access, write",
	.topic = "core imp def",
	.long_desc = "Attributable Level 1 data or unified TLB access, write",
},
{
	.name = "l2d_tlb_refill_rd",
	.event = "event=0x5c",
	.desc = "L2D cache refill, read",
	.topic = "core imp def",
	.long_desc = "Attributable Level 2 data or unified TLB refill, read",
},
{
	.name = "l2d_tlb_refill_wr",
	.event = "event=0x5d",
	.desc = "L2D cache refill, write",
	.topic = "core imp def",
	.long_desc = "Attributable Level 2 data or unified TLB refill, write",
},
{
	.name = "l2d_tlb_rd",
	.event = "event=0x5e",
	.desc = "L2D cache access, read",
	.topic = "core imp def",
	.long_desc = "Attributable Level 2 data or unified TLB access, read",
},
{
	.name = "l2d_tlb_wr",
	.event = "event=0x5f",
	.desc = "L2D cache access, write",
	.topic = "core imp def",
	.long_desc = "Attributable Level 2 data or unified TLB access, write",
},
{
	.name = "bus_access_rd",
	.event = "event=0x60",
	.desc = "Bus access read",
	.topic = "core imp def",
	.long_desc = "Bus access read",
},
{
	.name = "bus_access_wr",
	.event = "event=0x61",
	.desc = "Bus access write",
	.topic = "core imp def",
	.long_desc = "Bus access write",
},
{
	.name = "mem_access_rd",
	.event = "event=0x66",
	.desc = "Data memory access, read",
	.topic = "core imp def",
	.long_desc = "Data memory access, read",
},
{
	.name = "mem_access_wr",
	.event = "event=0x67",
	.desc = "Data memory access, write",
	.topic = "core imp def",
	.long_desc = "Data memory access, write",
},
{
	.name = "unaligned_ld_spec",
	.event = "event=0x68",
	.desc = "Unaligned access, read",
	.topic = "core imp def",
	.long_desc = "Unaligned access, read",
},
{
	.name = "unaligned_st_spec",
	.event = "event=0x69",
	.desc = "Unaligned access, write",
	.topic = "core imp def",
	.long_desc = "Unaligned access, write",
},
{
	.name = "unaligned_ldst_spec",
	.event = "event=0x6a",
	.desc = "Unaligned access",
	.topic = "core imp def",
	.long_desc = "Unaligned access",
},
{
	.name = "exc_undef",
	.event = "event=0x81",
	.desc = "Exception taken, Other synchronous",
	.topic = "core imp def",
	.long_desc = "Exception taken, Other synchronous",
},
{
	.name = "exc_svc",
	.event = "event=0x82",
	.desc = "Exception taken, Supervisor Call",
	.topic = "core imp def",
	.long_desc = "Exception taken, Supervisor Call",
},
{
	.name = "exc_pabort",
	.event = "event=0x83",
	.desc = "Exception taken, Instruction Abort",
	.topic = "core imp def",
	.long_desc = "Exception taken, Instruction Abort",
},
{
	.name = "exc_dabort",
	.event = "event=0x84",
	.desc = "Exception taken, Data Abort and SError",
	.topic = "core imp def",
	.long_desc = "Exception taken, Data Abort and SError",
},
{
	.name = "exc_irq",
	.event = "event=0x86",
	.desc = "Exception taken, IRQ",
	.topic = "core imp def",
	.long_desc = "Exception taken, IRQ",
},
{
	.name = "exc_fiq",
	.event = "event=0x87",
	.desc = "Exception taken, FIQ",
	.topic = "core imp def",
	.long_desc = "Exception taken, FIQ",
},
{
	.name = "exc_smc",
	.event = "event=0x88",
	.desc = "Exception taken, Secure Monitor Call",
	.topic = "core imp def",
	.long_desc = "Exception taken, Secure Monitor Call",
},
{
	.name = "exc_hvc",
	.event = "event=0x8a",
	.desc = "Exception taken, Hypervisor Call",
	.topic = "core imp def",
	.long_desc = "Exception taken, Hypervisor Call",
},
{
	.name = "exc_trap_pabort",
	.event = "event=0x8b",
	.desc = "Exception taken, Instruction Abort not taken locally",
	.topic = "core imp def",
	.long_desc = "Exception taken, Instruction Abort not taken locally",
},
{
	.name = "exc_trap_dabort",
	.event = "event=0x8c",
	.desc = "Exception taken, Data Abort or SError not taken locally",
	.topic = "core imp def",
	.long_desc = "Exception taken, Data Abort or SError not taken locally",
},
{
	.name = "exc_trap_other",
	.event = "event=0x8d",
	.desc = "Exception taken, Other traps not taken locally",
	.topic = "core imp def",
	.long_desc = "Exception taken, Other traps not taken locally",
},
{
	.name = "exc_trap_irq",
	.event = "event=0x8e",
	.desc = "Exception taken, IRQ not taken locally",
	.topic = "core imp def",
	.long_desc = "Exception taken, IRQ not taken locally",
},
{
	.name = "exc_trap_fiq",
	.event = "event=0x8f",
	.desc = "Exception taken, FIQ not taken locally",
	.topic = "core imp def",
	.long_desc = "Exception taken, FIQ not taken locally",
},
{
	.name = 0,
	.event = 0,
	.desc = 0,
},
};
struct pmu_event pme_hisilicon_hip08[] = {
{
	.name = "l1d_cache_rd",
	.event = "event=0x40",
	.desc = "L1D cache access, read",
	.topic = "core imp def",
	.long_desc = "Attributable Level 1 data cache access, read",
},
{
	.name = "l1d_cache_wr",
	.event = "event=0x41",
	.desc = "L1D cache access, write",
	.topic = "core imp def",
	.long_desc = "Attributable Level 1 data cache access, write",
},
{
	.name = "l1d_cache_refill_rd",
	.event = "event=0x42",
	.desc = "L1D cache refill, read",
	.topic = "core imp def",
	.long_desc = "Attributable Level 1 data cache refill, read",
},
{
	.name = "l1d_cache_refill_wr",
	.event = "event=0x43",
	.desc = "L1D cache refill, write",
	.topic = "core imp def",
	.long_desc = "Attributable Level 1 data cache refill, write",
},
{
	.name = "l1d_cache_wb_victim",
	.event = "event=0x46",
	.desc = "L1D cache Write-Back, victim",
	.topic = "core imp def",
	.long_desc = "Attributable Level 1 data cache Write-Back, victim",
},
{
	.name = "l1d_cache_wb_clean",
	.event = "event=0x47",
	.desc = "L1D cache Write-Back, cleaning and coherency",
	.topic = "core imp def",
	.long_desc = "Level 1 data cache Write-Back, cleaning and coherency",
},
{
	.name = "l1d_cache_inval",
	.event = "event=0x48",
	.desc = "L1D cache invalidate",
	.topic = "core imp def",
	.long_desc = "Attributable Level 1 data cache invalidate",
},
{
	.name = "l1d_tlb_refill_rd",
	.event = "event=0x4c",
	.desc = "L1D tlb refill, read",
	.topic = "core imp def",
	.long_desc = "Attributable Level 1 data TLB refill, read",
},
{
	.name = "l1d_tlb_refill_wr",
	.event = "event=0x4d",
	.desc = "L1D tlb refill, write",
	.topic = "core imp def",
	.long_desc = "Attributable Level 1 data TLB refill, write",
},
{
	.name = "l1d_tlb_rd",
	.event = "event=0x4e",
	.desc = "L1D tlb access, read",
	.topic = "core imp def",
	.long_desc = "Attributable Level 1 data or unified TLB access, read",
},
{
	.name = "l1d_tlb_wr",
	.event = "event=0x4f",
	.desc = "L1D tlb access, write",
	.topic = "core imp def",
	.long_desc = "Attributable Level 1 data or unified TLB access, write",
},
{
	.name = "l2d_cache_rd",
	.event = "event=0x50",
	.desc = "L2D cache access, read",
	.topic = "core imp def",
	.long_desc = "Attributable Level 2 data cache access, read",
},
{
	.name = "l2d_cache_wr",
	.event = "event=0x51",
	.desc = "L2D cache access, write",
	.topic = "core imp def",
	.long_desc = "Attributable Level 2 data cache access, write",
},
{
	.name = "l2d_cache_refill_rd",
	.event = "event=0x52",
	.desc = "L2D cache refill, read",
	.topic = "core imp def",
	.long_desc = "Attributable Level 2 data cache refill, read",
},
{
	.name = "l2d_cache_refill_wr",
	.event = "event=0x53",
	.desc = "L2D cache refill, write",
	.topic = "core imp def",
	.long_desc = "Attributable Level 2 data cache refill, write",
},
{
	.name = "l2d_cache_wb_victim",
	.event = "event=0x56",
	.desc = "L2D cache Write-Back, victim",
	.topic = "core imp def",
	.long_desc = "Attributable Level 2 data cache Write-Back, victim",
},
{
	.name = "l2d_cache_wb_clean",
	.event = "event=0x57",
	.desc = "L2D cache Write-Back, cleaning and coherency",
	.topic = "core imp def",
	.long_desc = "Level 2 data cache Write-Back, cleaning and coherency",
},
{
	.name = "l2d_cache_inval",
	.event = "event=0x58",
	.desc = "L2D cache invalidate",
	.topic = "core imp def",
	.long_desc = "Attributable Level 2 data cache invalidate",
},
{
	.name = "l1i_cache_prf",
	.event = "event=0x102e",
	.desc = "L1I cache prefetch access count",
	.topic = "core imp def",
	.long_desc = "Level 1 instruction cache prefetch access count",
},
{
	.name = "l1i_cache_prf_refill",
	.event = "event=0x102f",
	.desc = "L1I cache miss due to prefetch access count",
	.topic = "core imp def",
	.long_desc = "Level 1 instruction cache miss due to prefetch access count",
},
{
	.name = "iq_is_empty",
	.event = "event=0x1043",
	.desc = "Instruction queue is empty",
	.topic = "core imp def",
	.long_desc = "Instruction queue is empty",
},
{
	.name = "if_is_stall",
	.event = "event=0x1044",
	.desc = "Instruction fetch stall cycles",
	.topic = "core imp def",
	.long_desc = "Instruction fetch stall cycles",
},
{
	.name = "fetch_bubble",
	.event = "event=0x2014",
	.desc = "Instructions can receive, but not send",
	.topic = "core imp def",
	.long_desc = "Instructions can receive, but not send",
},
{
	.name = "prf_req",
	.event = "event=0x6013",
	.desc = "Prefetch request from LSU",
	.topic = "core imp def",
	.long_desc = "Prefetch request from LSU",
},
{
	.name = "hit_on_prf",
	.event = "event=0x6014",
	.desc = "Hit on prefetched data",
	.topic = "core imp def",
	.long_desc = "Hit on prefetched data",
},
{
	.name = "exe_stall_cycle",
	.event = "event=0x7001",
	.desc = "Cycles of that the number of issue ups are less than 4",
	.topic = "core imp def",
	.long_desc = "Cycles of that the number of issuing micro operations are less than 4",
},
{
	.name = "mem_stall_anyload",
	.event = "event=0x7004",
	.desc = "No any micro operation is issued and meanwhile any load operation is not resolved",
	.topic = "core imp def",
	.long_desc = "No any micro operation is issued and meanwhile any load operation is not resolved",
},
{
	.name = "mem_stall_l1miss",
	.event = "event=0x7006",
	.desc = "No any micro operation is issued and meanwhile there is any load operation missing L1 cache and pending data refill",
	.topic = "core imp def",
	.long_desc = "No any micro operation is issued and meanwhile there is any load operation missing L1 cache and pending data refill",
},
{
	.name = "mem_stall_l2miss",
	.event = "event=0x7007",
	.desc = "No any micro operation is issued and meanwhile there is any load operation missing both L1 and L2 cache and pending data refill from L3 cache",
	.topic = "core imp def",
	.long_desc = "No any micro operation is issued and meanwhile there is any load operation missing both L1 and L2 cache and pending data refill from L3 cache",
},
{
	.name = 0,
	.event = 0,
	.desc = 0,
},
};
struct pmu_event pme_arm_cortex_a53[] = {
{
	.name = "bus_access_rd",
	.event = "event=0x60",
	.desc = "Bus access read",
	.topic = "bus",
	.long_desc = "Bus access read",
},
{
	.name = "bus_access_wr",
	.event = "event=0x61",
	.desc = "Bus access write",
	.topic = "bus",
	.long_desc = "Bus access write",
},
{
	.name = "prefetch_linefill",
	.event = "event=0xc2",
	.desc = "Linefill because of prefetch",
	.topic = "cache",
},
{
	.name = "prefetch_linefill_drop",
	.event = "event=0xc3",
	.desc = "Instruction Cache Throttle occurred",
	.topic = "cache",
},
{
	.name = "read_alloc_enter",
	.event = "event=0xc4",
	.desc = "Entering read allocate mode",
	.topic = "cache",
},
{
	.name = "read_alloc",
	.event = "event=0xc5",
	.desc = "Read allocate mode",
	.topic = "cache",
},
{
	.name = "ext_snoop",
	.event = "event=0xc8",
	.desc = "SCU Snooped data from another CPU for this CPU",
	.topic = "cache",
},
{
	.name = "br_indirect_spec",
	.event = "event=0x7a",
	.desc = "Branch speculatively executed, indirect branch",
	.topic = "branch",
	.long_desc = "Branch speculatively executed, indirect branch",
},
{
	.name = "br_cond",
	.event = "event=0xc9",
	.desc = "Conditional branch executed",
	.topic = "branch",
},
{
	.name = "br_indirect_mispred",
	.event = "event=0xca",
	.desc = "Indirect branch mispredicted",
	.topic = "branch",
},
{
	.name = "br_indirect_mispred_addr",
	.event = "event=0xcb",
	.desc = "Indirect branch mispredicted because of address miscompare",
	.topic = "branch",
},
{
	.name = "br_cond_mispred",
	.event = "event=0xcc",
	.desc = "Conditional branch mispredicted",
	.topic = "branch",
},
{
	.name = "exc_irq",
	.event = "event=0x86",
	.desc = "Exception taken, IRQ",
	.topic = "other",
	.long_desc = "Exception taken, IRQ",
},
{
	.name = "exc_fiq",
	.event = "event=0x87",
	.desc = "Exception taken, FIQ",
	.topic = "other",
	.long_desc = "Exception taken, FIQ",
},
{
	.name = "pre_decode_err",
	.event = "event=0xc6",
	.desc = "Pre-decode error",
	.topic = "other",
},
{
	.name = "l1i_cache_err",
	.event = "event=0xd0",
	.desc = "L1 Instruction Cache (data or tag) memory error",
	.topic = "other",
},
{
	.name = "l1d_cache_err",
	.event = "event=0xd1",
	.desc = "L1 Data Cache (data, tag or dirty) memory error, correctable or non-correctable",
	.topic = "other",
},
{
	.name = "tlb_err",
	.event = "event=0xd2",
	.desc = "TLB memory error",
	.topic = "other",
},
{
	.name = "ext_mem_req",
	.event = "event=0xc0",
	.desc = "External memory request",
	.topic = "memory",
},
{
	.name = "ext_mem_req_nc",
	.event = "event=0xc1",
	.desc = "Non-cacheable external memory request",
	.topic = "memory",
},
{
	.name = "stall_sb_full",
	.event = "event=0xc7",
	.desc = "Data Write operation that stalls the pipeline because the store buffer is full",
	.topic = "pipeline",
},
{
	.name = "other_iq_dep_stall",
	.event = "event=0xe0",
	.desc = "Cycles that the DPU IQ is empty and that is not because of a recent micro-TLB miss, instruction cache miss or pre-decode error",
	.topic = "pipeline",
},
{
	.name = "ic_dep_stall",
	.event = "event=0xe1",
	.desc = "Cycles the DPU IQ is empty and there is an instruction cache miss being processed",
	.topic = "pipeline",
},
{
	.name = "iutlb_dep_stall",
	.event = "event=0xe2",
	.desc = "Cycles the DPU IQ is empty and there is an instruction micro-TLB miss being processed",
	.topic = "pipeline",
},
{
	.name = "decode_dep_stall",
	.event = "event=0xe3",
	.desc = "Cycles the DPU IQ is empty and there is a pre-decode error being processed",
	.topic = "pipeline",
},
{
	.name = "other_interlock_stall",
	.event = "event=0xe4",
	.desc = "Cycles there is an interlock other than  Advanced SIMD/Floating-point instructions or load/store instruction",
	.topic = "pipeline",
},
{
	.name = "agu_dep_stall",
	.event = "event=0xe5",
	.desc = "Cycles there is an interlock for a load/store instruction waiting for data to calculate the address in the AGU",
	.topic = "pipeline",
},
{
	.name = "simd_dep_stall",
	.event = "event=0xe6",
	.desc = "Cycles there is an interlock for an Advanced SIMD/Floating-point operation",
	.topic = "pipeline",
},
{
	.name = "ld_dep_stall",
	.event = "event=0xe7",
	.desc = "Cycles there is a stall in the Wr stage because of a load miss",
	.topic = "pipeline",
},
{
	.name = "st_dep_stall",
	.event = "event=0xe8",
	.desc = "Cycles there is a stall in the Wr stage because of a store",
	.topic = "pipeline",
},
{
	.name = 0,
	.event = 0,
	.desc = 0,
},
};
struct pmu_events_map pmu_events_map[] = {
{
	.cpuid = "0x00000000410fd03[[:xdigit:]]",
	.version = "v1",
	.type = "core",
	.table = pme_arm_cortex_a53
},
{
	.cpuid = "0x00000000420f5160",
	.version = "v1",
	.type = "core",
	.table = pme_cavium_thunderx2
},
{
	.cpuid = "0x00000000430f0af0",
	.version = "v1",
	.type = "core",
	.table = pme_cavium_thunderx2
},
{
	.cpuid = "0x00000000480fd010",
	.version = "v1",
	.type = "core",
	.table = pme_hisilicon_hip08
},
{
	.cpuid = "0x00000000500f0000",
	.version = "v1",
	.type = "core",
	.table = pme_ampere_emag
},
{
	.cpuid = 0,
	.version = 0,
	.type = 0,
	.table = 0,
},
};
